typedef struct Sess Sess;
typedef struct Node Node;

typedef int (*Scanfunc)(Node *n, Sess *s);
typedef int (*Walkfunc)(Node *n, Sess *s, char *name);
typedef int (*Flushfunc)(Node *n, Sess *s, void *buf, int len);

#pragma incomplete Node

struct Sess  {
	char *url;			/* host URL */
	char version[128];	/* server version */
	char *webfs;		/* where to find webfs */
	int conid;			/* /net connection ID */
	int fd;				/* webfs session */
	char *buildtoken;	/* token needed to kick off builds */
	int annon;			/* don't authenticate */
	char *user;			/* authenticated user name */
};

typedef struct Node Node;
struct Node {
	Node *parent;
	Node *child;
	Node *next;
	Dir dir;

	char *buf;			/* read content */
	char *url;			/* url to load content from */
	Scanfunc scan;		/* called on open of a dir, reload dir contents */
	Walkfunc walk;		/* called on walk, check dir exists */
	Flushfunc flush;	/* called on destroyfid, flush written file */
	int mkdir;			/* create: allow dirs creation, not files */
	long last;			/* time(2) data last refreshed */
	void *aux;			/* understood by lower layers */
};


/* api.c */
int jobscan(Node *n, Sess *s);
int jobwalk(Node *n, Sess *s, char *name);
int jobscan(Node *n, Sess *s);
int usrwalk(Node *n, Sess *s, char *name);
int usrscan(Node *n, Sess *s);
int serverscan(Node *n, Sess *s);
int hostscan(Node *n, Sess *s);

/* httperrstr.c */
void httperrstr(int n);

/* main.c */
Node *newdir(Node *n, char *uid, char *gid, char *muid, char *name);
Node *newfile(Node *n, char *name, char *uid, char *gid, char *muid, long mtime, long atime, char *text);
Node *newurl(Node *n, char *name, char *uid, char *gid, char *muid, long mtime, vlong size, char *url);
void writable(Node *n);

/* misc.c */
void warn(char *fmt, ...);
char *strlwr(char *str);
char *strupr(char *str);
Jvalue *exch(Sess *s, char *post, char *fmt, ...);
int httphdr(Sess *s, char *field, char *buf, int len);
char *fetch(Sess *s, vlong *len, char *fmt, ...);
int dialweb(Sess *s);
long iso2sec(char *s);
char *basename(char *s);
char *getkey(char *attr, char *fmt, ...);

char *Debug;

